package MV;

import javax.swing.*;

import javax.swing.event.*;

import java.awt.*;

import java.awt.event.*;

import java.io.*;

import java.util.*;

import javax.swing.JDialog.*;

import javax.swing.border.*;

import java.lang.*;



public class NewMolecule extends JFrame implements ActionListener,ItemListener,MouseListener,MouseMotionListener

{

	MainPanel myMainPanel;

	Label text;

	Box box,MainBox;

	Choice elementChoice, bondChoice;

	File Elements;

	String s;

	JButton AddE,AddB,RESET,SAVE,EXIT;

	Font f;

	JPanel DrawPanel,ColorPanel;

	String atomName,bondName;

	Graphics g;

	Vector atom,Bonds;

	int no_atoms,dragAtom,no_bonds,bondatomno;

	NewAtom myatom;

	Bond mybond;

	boolean canDrawBond;

	String newMoleculeName;	



	NewMolecule(MainPanel myMainPanel)

	{

		this.myMainPanel = myMainPanel;

		newMoleculeName = "";

		dragAtom = 0;

		no_atoms = 0;

		no_bonds = 0;

		bondatomno=0;

		canDrawBond = false;

		setSize( new Dimension(500,570));

        	setTitle("Create a new Molecule");

        	TitledBorder tb1 = new TitledBorder( new LineBorder(Color.black),"");

                tb1.setTitleColor(Color.red);

                f = new Font("Dialog",Font.BOLD,15 );

		setFont(f);   	        

		

		MainBox = Box.createVerticalBox();

        	JPanel elementChooser = new JPanel();

        	elementChooser.setPreferredSize(new Dimension(490,20));

        	text = new Label("Choose the Element ");

               	text.setForeground(Color.blue);

        	text.setFont(f);

          	box = Box.createHorizontalBox();

          	box.add(text);

          	box.add(Box.createHorizontalGlue());

          	elementChoice = new Choice();

          	try{

        	  	FileReader Elements = new FileReader("MV\\Elements.txt");

      			BufferedReader br = new BufferedReader(Elements);

      			while( (s=br.readLine())!=null )

      			{

      				elementChoice.add(s);

      			}

      		}catch(Exception e){}	

      		elementChoice.select(0);	

      		elementChoice.addItemListener(this);

      		atomName = (String)elementChoice.getSelectedItem();

          	box.add(elementChoice);

          	AddE = new JButton("Add Element");

          	AddE.addActionListener(this);

          	box.add(Box.createHorizontalGlue());

          	box.add(AddE);

          	elementChooser.add(box);

          	elementChooser.setBorder(tb1);                 

              	MainBox.add( elementChooser );

              	

              	JPanel bondChooser = new JPanel();

              	box = Box.createHorizontalBox();              	

              	bondChooser.setPreferredSize(new Dimension(490,20));

        	text = new Label("Choose the Bond ");

               	text.setForeground(Color.blue);

        	text.setFont(f);

          	box = Box.createHorizontalBox();

          	box.add(text);

          	box.add(Box.createHorizontalGlue());

          	bondChoice = new Choice();

          	bondChoice.add("Single Bond");

          	bondChoice.add("Double Bond");

          	bondChoice.add("Triple Bond");

        	bondChoice.select(0);

        	bondChoice.addItemListener(this);

        	box.add(bondChoice);

        	AddB = new JButton("Add Bond");

        	AddB.addActionListener(this);

        	box.add(Box.createHorizontalGlue());

        	box.add(AddB);        	

        	bondChooser.add(box);

        	bondChooser.setBorder(tb1);

        	MainBox.add(bondChooser);

        	

        	ColorPanel = new JPanel();

        	ColorPanel.setPreferredSize(new Dimension(490,13));

        	ColorPanel.setBorder(tb1);

        	box = Box.createHorizontalBox();

        	f = new Font("Sanserif",Font.BOLD,13);

        	text = new Label("Single Bond : White ");

               	text.setForeground(Color.white);

        	text.setFont(f);     	

 		box.add(text);

 		text = new Label("Double Bond : Red ");

               	text.setForeground(Color.red);

        	text.setFont(f);     	

 		box.add(text);

 		text = new Label("Triple Bond : Blue ");

               	text.setForeground(Color.blue);

        	text.setFont(f);     	

 		box.add(text); 

 		ColorPanel.add(box);

        	MainBox.add(ColorPanel);

        	

        	

        	DrawPanel = new JPanel();

        	DrawPanel.setPreferredSize(new Dimension(490,330));

        	DrawPanel.setBorder(tb1);

        	DrawPanel.setBackground(Color.black);

        	DrawPanel.addMouseListener(this);

        	DrawPanel.addMouseMotionListener(this);

        	MainBox.add(DrawPanel);

        	

        	JPanel LastPanel = new JPanel();

        	LastPanel.setPreferredSize(new Dimension(490,5));

        	box = Box.createHorizontalBox();

        	RESET = new JButton("Clear");

        	SAVE = new JButton("Save");

        	EXIT = new JButton("Exit");

        	RESET.addActionListener(this);

        	SAVE.addActionListener(this);

        	EXIT.addActionListener(this);

        	box.add(RESET);

        	box.add(SAVE);

        	box.add(EXIT); 

        	LastPanel.add(box);

        	MainBox.add(LastPanel);

        	

        	getContentPane().add(MainBox);

        	setVisible(true);

        	show();

        	atom = new Vector(15,1);

        	Bonds = new Vector(20,1);

        	g = DrawPanel.getGraphics();

	}

	

	public void mouseClicked(MouseEvent me)

	{

		dragAtom = insideAtom(me.getX(),me.getY());

		if( dragAtom!= 0 && canDrawBond)

		{

			myatom = (NewAtom)atom.elementAt(dragAtom-1);	

			myatom.Draw(g,Color.pink); 

							

			if( bondatomno==1 )

			{	bondatomno++;

				mybond.setAtom1(myatom);

				myatom.setMovable(false); 

			}

			else if( bondatomno==2 )	

			{	canDrawBond = false;

				bondatomno=0;

				mybond.setAtom2(myatom);

				mybond.Draw(g);		

				Bonds.addElement(mybond);

				mybond.getAtom1().Draw(g,Color.yellow);

				mybond.getAtom2().Draw(g,Color.yellow);

				myatom.setMovable(false);		

			}

		}		

	}

	

	public void mouseEntered(MouseEvent me){}

	

	public void mouseExited(MouseEvent me){}

	

	public void mouseDragged(MouseEvent me)

	{

		if( canDrawBond ) return;

		dragAtom = insideAtom(me.getX(),me.getY());

		if( dragAtom!=0 )  

		{	DrawBonds();	

			myatom = (NewAtom)atom.elementAt(dragAtom-1);

			Clear(myatom);

			myatom.setX(me.getX());

			myatom.setY(me.getY()); 

			myatom.Draw(g,Color.yellow);

		}

		

	}

	

	public void Clear( NewAtom clear_atom )

	{

		int x = clear_atom.getX(), y = clear_atom.getY(),xx,yy,i=0,distance;

		clear_atom.Clear(g);

		NewAtom tempAtom;

		while( i < no_atoms )

		{

			tempAtom = (NewAtom)atom.elementAt(i);

			if( !tempAtom.equals(clear_atom) )

			{

				xx = tempAtom.getX();  yy = tempAtom.getY();

				if( (x-xx)*(x-xx)+(y-yy)*(y-yy) < 400 ) tempAtom.Draw(g,tempAtom.getcolor());

		

			}

			i++;

		}	 

	}	

	

	public void mousePressed(MouseEvent me){  }

		

	public void mouseReleased(MouseEvent me){ }

	

	public void mouseMoved(MouseEvent me){}

	

	public void actionPerformed(ActionEvent ae)

	{

		String command = (String)ae.getActionCommand();

		if( command.equals("Add Element") )

		{

			atomName = (String)elementChoice.getSelectedItem();

			no_atoms++;

			myatom = new NewAtom(20,20,atomName,no_atoms);

			atom.addElement( myatom ); 

			myatom.Draw(g,Color.white);			

		}

		else if( command.equals("Add Bond") )

		{

			canDrawBond = true;

			bondName = (String)bondChoice.getSelectedItem();

			no_bonds++; 

			mybond = new Bond(bondName);

			bondatomno = 1;

		}		

		else if( command.equals("Save") )

		{

			Save();

		}

		else if( command.equals("Exit") )

		{

			dispose();

		}

		else if( command.equals("Clear") )

		{

			atom = new Vector(15,1);

			Bonds = new Vector(20,1);

			g.setColor(Color.black);

			g.fillRect(0,0,490,330);	

			dragAtom = 0;

			no_atoms = 0;

			no_bonds = 0;

			bondatomno=0;

			canDrawBond = false;

			newMoleculeName = "";

		}	

	} 

	

	public void itemStateChanged(ItemEvent ie){}	

	

	public int insideAtom(int x,int y)

	{

		int i=0,my_x,my_y,distance;

		while(i<no_atoms)

		{

			myatom = (NewAtom)atom.elementAt(i);

			my_x = myatom.getX();  my_y = myatom.getY();

			distance = (my_x-x)*(my_x-x) + (my_y-y)*(my_y-y) ;

			if(  distance <= 100 )

				return myatom.getAtom_no();

			i++;

		}

		return 0;		

	}	

	

	public void DrawBonds()

	{

		int i=0;

		while( i < no_bonds )

		{ 

			mybond = (Bond)Bonds.elementAt(i);

			mybond.Draw(g);

			i++;

		}

	}	

	

	public void Save()

	{

		if( no_atoms - no_bonds > 1 )

		{	MoleculeError();	return;	}

		

		Bond tempBond;

		

		for( int i=0; i<no_atoms; i++ )

		{

			myatom = (NewAtom)atom.elementAt(i);

			for( int j=0; j<no_bonds; j++ )

			{

				tempBond = (Bond)Bonds.elementAt(j);

				if( (tempBond.getAtom1()).equals(myatom) )

					myatom.BondedNeighbour(tempBond.getAtom2(),tempBond.getType());

				else if( (tempBond.getAtom2()).equals(myatom) )

					myatom.BondedNeighbour(tempBond.getAtom1(),tempBond.getType());

			}

			int VE=myatom.getVE();

			int SB=myatom.getSB(),	DB=myatom.getDB(),	TB=myatom.getTB();

			int diff = VE-SB-DB*2-TB*3;

			String n = myatom.getAtomName();

			if( diff%2==1 )	{	MoleculeError();	return;	}

			if( diff<0 )	{	MoleculeError();	return;	}

			if( diff!=0 )

				if( n.equals("C") || n.equals("H") ){	MoleculeError();	return; }

			

			if( diff==0 && n.equals("O") ){	MoleculeError();	return;	} 	

		}

				

		// Start the construction.	

		NewAtom root = (NewAtom)atom.elementAt(0);

		root.setPVx(1.0);  root.setPVy(0);   root.setPVz(0);

		root.setCord(0,0,0);

		VisitAtom(root);

			

		originSetting();

		screenFitting();

		

		MoleculeInput mi = new MoleculeInput(this,true);

		mi.setVisible(true);

		if(mi.getName()=="")	return;

		newMoleculeName = mi.getName();

		

		try{

			FileWriter fin = new FileWriter("MV\\Models\\"+newMoleculeName+".xyz");

		 	for(int i=0;i<no_atoms;i++)

			{

				myatom = (NewAtom)atom.elementAt(i);

				fin.write(myatom.getAtomName());

				fin.write("\n"+(float)myatom.getCordX() );

				fin.write("\n"+(float)myatom.getCordY());

				fin.write("\n"+(float)myatom.getCordZ()+"\n");

			}

			fin.close();

			

			FileReader fr = new FileReader("MV\\MoleculeList.txt");

			BufferedReader br = new BufferedReader(fr);

     			String s;

			while( (s=br.readLine())!=null && s!="\n") 			

     			{     	

     				if( s.equalsIgnoreCase(mi.getName()) )

				{	fr.close();

					return;

				}	

     			}

			fr.close(); 

			

			fin = new FileWriter("MV\\MoleculeList.txt",true);

			fin.write(mi.getName()+"\n" );

			fin.close();

		}catch(Exception e){ System.out.println("Unable to save"); }

		

		myMainPanel.setNewMoleculeName(newMoleculeName);

		

		try{

			FileWriter fw = new FileWriter("MV\\Bonds\\"+mi.getName()+".xyz");

			for(int i=0;i<no_bonds;i++)

			{

				tempBond = (Bond)Bonds.elementAt(i);

				fw.write(tempBond.getType()+"\n");

				fw.write((tempBond.getAtom1()).getAtom_no()+"\n");

				fw.write((tempBond.getAtom2()).getAtom_no()+"\n");

			}

			fw.close();

		}catch(Exception e){System.out.println("Cant save atom no");}

		

		atom = new Vector(15,1);

		Bonds = new Vector(20,1);

		g.setColor(Color.black);

		g.fillRect(0,0,490,330);	

		dragAtom = 0;

		no_atoms = 0;

		no_bonds = 0;

		bondatomno=0;

		canDrawBond = false;

		newMoleculeName = "";

	}	 



	public void VisitAtom( NewAtom atom )

	{

		double ax = atom.getPVx(), ay = atom.getPVy(), az = atom.getPVz();

		double x = atom.getCordX(), y = atom.getCordY(), z = atom.getCordZ();

		double nx,ny,nz;

		atom.setVisited(true);

		Vector N = atom.getNeighbours();	

		int GeomNo,no_neigh=N.size();

		float BL=0;

		int VE=atom.getVE();

		int SB=atom.getSB(),	DB=atom.getDB(),	TB=atom.getTB();

		GeomNo = SB+DB+TB + (VE-SB-2*DB-3*TB)/2;

		

		if( GeomNo == 1 )

		{	if ( ((NewAtom)N.elementAt(0)).getVisited()==false )

			{

				NewAtom neigh1 = (NewAtom)N.elementAt(0);

				BL = getBondLength(atom.getAtomName(),neigh1.getAtomName());

				neigh1.setPVx( ax );

				neigh1.setPVy( ay );

				neigh1.setPVz( az );

				neigh1.setCord( x + neigh1.getPVx()*BL , y + neigh1.getPVy()*BL , z + neigh1.getPVz()*BL );

                        	VisitAtom( neigh1 );

			}

			return;

			

		}	



		else if( GeomNo == 2 )

		{

			NewAtom neigh1 = (NewAtom)N.elementAt(0);

			NewAtom neigh2 = neigh1;

			if( no_neigh==2 )	neigh2 = (NewAtom)N.elementAt(1);

			

			if( neigh1.getVisited()==true && no_neigh==2 )

			{

				neigh1=neigh2;

				BL = getBondLength(atom.getAtomName(),neigh1.getAtomName());

				neigh1.setPVx( ax );

				neigh1.setPVy( ay );

				neigh1.setPVz( az );

				neigh1.setCord( x + neigh1.getPVx()*BL , y + neigh1.getPVy()*BL , z + neigh1.getPVz()*BL );

                        	VisitAtom( neigh1 );

			}

			else 

			{

				BL = getBondLength(atom.getAtomName(),neigh1.getAtomName());

				neigh1.setPVx( ax );

				neigh1.setPVy( ay );

				neigh1.setPVz( az );

				neigh1.setCord( x + neigh1.getPVx()*BL , y + neigh1.getPVy()*BL , z + neigh1.getPVz()*BL );

                        	VisitAtom( neigh1 );

                        	

                        	if( neigh2.getVisited()==false)

                        	{

					BL = getBondLength(atom.getAtomName(),neigh2.getAtomName());

					neigh2.setPVx( -ax );

					neigh2.setPVy( -ay );

					neigh2.setPVz( -az );

					neigh2.setCord( x + neigh2.getPVx()*BL , y + neigh2.getPVy()*BL , z + neigh2.getPVz()*BL );

                        		VisitAtom( neigh2 );

                        	}	

			}

			return;

		}



		else if( GeomNo==3 )

		{

			NewAtom neigh1,neigh2,neigh3;

			neigh1 = (NewAtom)N.elementAt(0);

			neigh2 = neigh1;	neigh3 = neigh1;

			NewAtom NA[] = new NewAtom[3];



			if( no_neigh>=2 ) 	neigh2=(NewAtom)N.elementAt(1);

			if( no_neigh==3 ) 	neigh3=(NewAtom)N.elementAt(2);



			NA[0] = neigh1; NA[1]=neigh2; NA[2]=neigh3; 

			int rand = (int)(3*Math.random());

			neigh1 = NA[rand];

			neigh2 = NA[(rand+1)%3];

			neigh3 = NA[(rand+2)%3];

		

			if( atom.getAtom_no()==1 )

			{	// IF ROOT

				BL = getBondLength(atom.getAtomName(),neigh3.getAtomName());

				neigh3.setPVx( -ax);  neigh3.setPVy(-ay);	neigh3.setPVz(-az);

				neigh3.setCord( x - ax*BL, y - ay*BL, z - az*BL );

				VisitAtom(neigh3);

			}	

			else

			{

				if( neigh1.getVisited()==true )	{	neigh1 = neigh2;	neigh2 = neigh3; }

				if( neigh2.getVisited()==true ) {       neigh2=neigh3; }

			}	

				

			/* set the Normal */

			

		        nz = 0;

			if( ay!=0 ){ nx = Math.random();  ny = -(ax*nx+az*nz)/ay; }

			else if(ax!=0){ ny = Math.random(); nx = -(ay*ny+az*nz)/ax; }

			else { nx = Math.random(); ny = Math.random(); nz = -(ax*nx+ay*ny)/az; }

			double r = Math.sqrt(nx*nx+ny*ny+nz*nz);

			nx = nx/r;	ny=ny/r;	nz=nz/r;

	 		if( neigh1.getVisited()==false ){

			BL = getBondLength(atom.getAtomName(),neigh1.getAtomName());

			neigh1.setPVx( (ax + 1.732*nx)/2 );

			neigh1.setPVy( (ay + 1.732*ny)/2 );

			neigh1.setPVz( (az + 1.732*nz)/2 );

			neigh1.setCord( x +BL*neigh1.getPVx() , y + BL*neigh1.getPVy() , z + BL*neigh1.getPVz() );

			VisitAtom(neigh1);

			}

			

			if( neigh2.getVisited()==false ){

			BL = getBondLength(atom.getAtomName(),neigh2.getAtomName());

			neigh2.setPVx( (ax - 1.732*nx)/2 );

			neigh2.setPVy( (ay - 1.732*ny)/2 );

			neigh2.setPVz( (az - 1.732*nz)/2 );

			neigh2.setCord( x + BL*neigh2.getPVx() ,  y + BL*neigh2.getPVy() , z + BL*neigh2.getPVz() );

			VisitAtom(neigh2);

			}

			return;

 		}	

		else if( GeomNo==4 )

		{

			NewAtom neigh1,neigh2,neigh3,neigh4;

			NewAtom NA[] = new NewAtom[4];

			neigh1 = (NewAtom)N.elementAt(0);

			neigh2 = neigh1;	neigh3 = neigh1;	neigh4 = neigh1;

			if( no_neigh>=2 )neigh2 = (NewAtom)N.elementAt(1);

			if( no_neigh>=3 )neigh3 = (NewAtom)N.elementAt(2);

			if( no_neigh==4 )neigh4 = (NewAtom)N.elementAt(3);

			

			NA[0] = neigh1; NA[1]=neigh2; NA[2]=neigh3; NA[3] = neigh4;

			int rand = (int)(4*Math.random());

			neigh1 = NA[rand];

			neigh2 = NA[(rand+1)%4];

			neigh3 = NA[(rand+2)%4];

			neigh4 = NA[(rand+3)%4];



			if( atom.getAtom_no()==1 )

			{	// IF ROOT

				BL = getBondLength(atom.getAtomName(),neigh4.getAtomName());

				neigh4.setPVx( -ax);  neigh4.setPVy(-ay);	neigh4.setPVz(-az);

				neigh4.setCord( x - ax*BL, y - ay*BL, z - az*BL );

				VisitAtom(neigh4);

			}	

			else

			{

				if( neigh1.getVisited()==true )	{	neigh1 = neigh2;  neigh2 = neigh3; neigh3=neigh4; }

				if( neigh2.getVisited()==true ) {       neigh2 = neigh3;  neigh3 = neigh4; }

				if( neigh3.getVisited()==true ) {	neigh3 = neigh4;  }

			}

			

			/* set the Normal */

		        if( az!=0 ){ nx = Math.random(); ny = Math.random(); nz = -(ax*nx+ay*ny)/az; }

			else if( ay!=0 ){ nx = Math.random(); nz = Math.random(); ny = -(ax*nx+az*nz)/ay; }

			else { ny = Math.random(); nz = Math.random(); nx = -(ay*ny+az*nz)/ax; }

			double r = Math.sqrt(nx*nx+ny*ny+nz*nz);

			nx = nx/r;	ny=ny/r;	nz=nz/r;

			double aXnx = ay*nz-ny*az, aXny = az*nx-ax*nz,  aXnz = ax*ny-ay*nx;

			

			if( neigh1.getVisited()==false ){

			BL = getBondLength(atom.getAtomName(),neigh1.getAtomName());

			neigh1.setPVx( ax*Sin(19) + nx*Cos(19) );

			neigh1.setPVy( ay*Sin(19) + ny*Cos(19) ) ;

			neigh1.setPVz( az*Sin(19) + nz*Cos(19) );

			neigh1.setCord( x +BL*neigh1.getPVx() , y + BL*neigh1.getPVy() , z + BL*neigh1.getPVz() );

			VisitAtom(neigh1);

			}

			

			if( neigh2.getVisited()==false ){

			BL = getBondLength(atom.getAtomName(),neigh2.getAtomName());

			neigh2.setPVx( ax*Sin(19) + nx*Cos(19)*Cos(120) + aXnx*Cos(19)*Sin(120) );

			neigh2.setPVy( ay*Sin(19) + ny*Cos(19)*Cos(120) + aXny*Cos(19)*Sin(120) );

			neigh2.setPVz( az*Sin(19) + nz*Cos(19)*Cos(120) + aXnz*Cos(19)*Sin(120) );

			neigh2.setCord( x + BL*neigh2.getPVx() ,  y + BL*neigh2.getPVy() , z + BL*neigh2.getPVz() );

			VisitAtom(neigh2);

			}

			

			if( neigh3.getVisited()==false ){

			BL = getBondLength(atom.getAtomName(),neigh3.getAtomName());

			neigh3.setPVx( ax*Sin(19) + nx*Cos(19)*Cos(120) - aXnx*Cos(19)*Sin(120) );

			neigh3.setPVy( ay*Sin(19) + ny*Cos(19)*Cos(120) - aXny*Cos(19)*Sin(120) );

			neigh3.setPVz( az*Sin(19) + nz*Cos(19)*Cos(120) - aXnz*Cos(19)*Sin(120) );

			neigh3.setCord( x + BL*neigh3.getPVx() ,  y + BL*neigh3.getPVy() , z + BL*neigh3.getPVz() );

			VisitAtom(neigh3);

			}

		}	

			

		else if( GeomNo==5 )

		{

			NewAtom neigh1,neigh2,neigh3,neigh4,neigh5;

			neigh1 = (NewAtom)N.elementAt(0);

			neigh2 = neigh1;	neigh3 = neigh1; neigh4 = neigh1;neigh5=neigh1;

			if( no_neigh>=2 )neigh2 = (NewAtom)N.elementAt(1);

			if( no_neigh>=3 )neigh3 = (NewAtom)N.elementAt(2);

			if( no_neigh>=4 )neigh4 = (NewAtom)N.elementAt(3);

			if( no_neigh==5 ) neigh5 = (NewAtom)N.elementAt(4);



			NewAtom NA[] = new NewAtom[5];

			NA[0] = neigh1; NA[1]=neigh2; NA[2]=neigh3; NA[3] = neigh4; NA[4]=neigh5;

			int rand = (int)(5*Math.random());

			neigh1 = NA[rand];

			neigh2 = NA[(rand+1)%5];

			neigh3 = NA[(rand+2)%5];

			neigh4 = NA[(rand+3)%5];

			neigh5 = NA[(rand+4)%5];

			

			if( atom.getAtom_no()==1 )

			{	// IF ROOT

				BL = getBondLength(atom.getAtomName(),neigh5.getAtomName());

				neigh5.setPVx( -ax);  neigh5.setPVy(-ay);	neigh5.setPVz(-az);

				neigh5.setCord( x - ax*BL, y - ay*BL, z - az*BL );

				VisitAtom(neigh5);

			}

			

			/* set the Normal */

		        if( az!=0 ){ nx = Math.random(); ny = Math.random(); nz = -(ax*nx+ay*ny)/az; }

			else if( ay!=0 ){ nx = Math.random(); nz = Math.random(); ny = -(ax*nx+az*nz)/ay; }

			else { ny = Math.random(); nz = Math.random(); nx = -(ay*ny+az*nz)/ax; }

			double r = Math.sqrt(nx*nx+ny*ny+nz*nz);

			nx = nx/r;	ny=ny/r;	nz=nz/r;

			double aXnx = ay*nz-ny*az, aXny = az*nx-ax*nz,  aXnz = ax*ny-ay*nx;

			

			if( neigh1.getVisited()==false ){

			BL = getBondLength(atom.getAtomName(),neigh1.getAtomName());

			neigh1.setPVx( ax );

			neigh1.setPVy( ay ) ;

			neigh1.setPVz( az );

			neigh1.setCord( x +BL*neigh1.getPVx() , y + BL*neigh1.getPVy() , z + BL*neigh1.getPVz() );

			VisitAtom(neigh1);

			}

			

			if( neigh2.getVisited()==false ){

			BL = getBondLength(atom.getAtomName(),neigh2.getAtomName());

			neigh2.setPVx( nx );

			neigh2.setPVy( ny );

			neigh2.setPVz( nz );

			neigh2.setCord( x + BL*neigh2.getPVx() ,  y + BL*neigh2.getPVy() , z + BL*neigh2.getPVz() );

			VisitAtom(neigh2);

			}

			

			if( neigh3.getVisited()==false ){

			BL = getBondLength(atom.getAtomName(),neigh3.getAtomName());

			neigh3.setPVx( nx*Cos(120) + aXnx*Sin(120) );

			neigh3.setPVy( ny*Cos(120) + aXny*Sin(120) );

			neigh3.setPVz( nz*Cos(120) + aXnz*Sin(120) );

			neigh3.setCord( x + BL*neigh3.getPVx() ,  y + BL*neigh3.getPVy() , z + BL*neigh3.getPVz() );

			VisitAtom(neigh3);

			}

			

			if( neigh4.getVisited()==false ){

			BL = getBondLength(atom.getAtomName(),neigh4.getAtomName());

			neigh4.setPVx( nx*Cos(120) - aXnx*Sin(120) );

			neigh4.setPVy( ny*Cos(120) - aXny*Sin(120) );

			neigh4.setPVz( nz*Cos(120) - aXnz*Sin(120) );

			neigh4.setCord( x + BL*neigh4.getPVx() ,  y + BL*neigh4.getPVy() , z + BL*neigh4.getPVz() );

			VisitAtom(neigh4);

			}

		}	

		

		else if( GeomNo==6 )

		{

			NewAtom neigh1,neigh2,neigh3,neigh4,neigh5,neigh6;

			neigh1 = (NewAtom)N.elementAt(0);

			neigh2 = neigh1; neigh3 = neigh1; neigh4 = neigh1; neigh5=neigh1; neigh6 = neigh1;

			if( no_neigh>=2 ) neigh2 = (NewAtom)N.elementAt(1);

			if( no_neigh>=3 ) neigh3 = (NewAtom)N.elementAt(2);

			if( no_neigh>=4 ) neigh4 = (NewAtom)N.elementAt(3);

			if( no_neigh>=5 ) neigh5 = (NewAtom)N.elementAt(4);

			if( no_neigh==6 ) neigh6 = (NewAtom)N.elementAt(5);

			

			NewAtom NA[] = new NewAtom[6];

			NA[0] = neigh1; NA[1]=neigh2; NA[2]=neigh3; NA[3] = neigh4; NA[4]=neigh5;

			NA[5] = neigh6;

			int rand = (int)(6*Math.random());

			neigh1 = NA[rand];

			neigh2 = NA[(rand+1)%6];

			neigh3 = NA[(rand+2)%6];

			neigh4 = NA[(rand+3)%6];

			neigh5 = NA[(rand+4)%6];

			neigh6 = NA[(rand+5)%6];



			if( atom.getAtom_no()==1 )

			{	// IF ROOT

				BL = getBondLength(atom.getAtomName(),neigh6.getAtomName());

				neigh6.setPVx( -ax);  neigh6.setPVy(-ay);	neigh6.setPVz(-az);

				neigh6.setCord( x - ax*BL, y - ay*BL, z - az*BL );

				VisitAtom(neigh6);

			}

			

			/* set the Normal */

		        if( az!=0 ){ nx = Math.random(); ny = Math.random(); nz = -(ax*nx+ay*ny)/az; }

			else if( ay!=0 ){ nx = Math.random(); nz = Math.random(); ny = -(ax*nx+az*nz)/ay; }

			else { ny = Math.random(); nz = Math.random(); nx = -(ay*ny+az*nz)/ax; }

			double r = Math.sqrt(nx*nx+ny*ny+nz*nz);

			nx = nx/r;	ny=ny/r;	nz=nz/r;

			double aXnx = ay*nz-ny*az, aXny = az*nx-ax*nz,  aXnz = ax*ny-ay*nx;

			

			if( neigh1.getVisited()==false ){

			BL = getBondLength(atom.getAtomName(),neigh1.getAtomName());

			neigh1.setPVx( ax );

			neigh1.setPVy( ay ) ;

			neigh1.setPVz( az );

			neigh1.setCord( x +BL*neigh1.getPVx() , y + BL*neigh1.getPVy() , z + BL*neigh1.getPVz() );

			VisitAtom(neigh1);

			}

			

			if( neigh2.getVisited()==false ){

			BL = getBondLength(atom.getAtomName(),neigh2.getAtomName());

			neigh2.setPVx( nx );

			neigh2.setPVy( ny );

			neigh2.setPVz( nz );

			neigh2.setCord( x + BL*neigh2.getPVx() ,  y + BL*neigh2.getPVy() , z + BL*neigh2.getPVz() );

			VisitAtom(neigh2);

			}

			

			if( neigh3.getVisited()==false ){

			BL = getBondLength(atom.getAtomName(),neigh3.getAtomName());

			neigh3.setPVx( -nx );

			neigh3.setPVy( -ny );

			neigh3.setPVz( -nz );

			neigh3.setCord( x + BL*neigh3.getPVx() ,  y + BL*neigh3.getPVy() , z + BL*neigh3.getPVz() );

			VisitAtom(neigh3);

			}

			

			if( neigh4.getVisited()==false ){

			BL = getBondLength(atom.getAtomName(),neigh4.getAtomName());

			neigh4.setPVx( aXnx );

			neigh4.setPVy( aXny );

			neigh4.setPVz( aXnz );

			neigh4.setCord( x + BL*neigh4.getPVx() ,  y + BL*neigh4.getPVy() , z + BL*neigh4.getPVz() );

			VisitAtom(neigh4);

			}

			

			if( neigh5.getVisited()==false ){

			BL = getBondLength(atom.getAtomName(),neigh5.getAtomName());

			neigh5.setPVx( -aXnx );

			neigh5.setPVy( -aXny );

			neigh5.setPVz( -aXnz );

			neigh5.setCord( x + BL*neigh5.getPVx() ,  y + BL*neigh5.getPVy() , z + BL*neigh5.getPVz() );

			VisitAtom(neigh5);

			}

			

		}

		

		else if( GeomNo==7 )

		{

			NewAtom neigh1,neigh2,neigh3,neigh4,neigh5,neigh6,neigh7;

			neigh1 = (NewAtom)N.elementAt(0);

			neigh2 = neigh1; neigh3 = neigh1; neigh4 = neigh1; neigh5=neigh1; neigh6 = neigh1; neigh7 = neigh1;

			if( no_neigh>=2 ) neigh2 = (NewAtom)N.elementAt(1);

			if( no_neigh>=3 ) neigh3 = (NewAtom)N.elementAt(2);

			if( no_neigh>=4 ) neigh4 = (NewAtom)N.elementAt(3);

			if( no_neigh>=5 ) neigh5 = (NewAtom)N.elementAt(4);

			if( no_neigh>=6 ) neigh6 = (NewAtom)N.elementAt(5);

			if( no_neigh==7 ) neigh7 = (NewAtom)N.elementAt(6);



			NewAtom NA[] = new NewAtom[7];

			NA[0] = neigh1; NA[1]=neigh2; NA[2]=neigh3; NA[3] = neigh4; NA[4]=neigh5;

			NA[5] = neigh6;	NA[6] = neigh7;

			int rand = (int)(7*Math.random());

			neigh1 = NA[rand];

			neigh2 = NA[(rand+1)%7];

			neigh3 = NA[(rand+2)%7];

			neigh4 = NA[(rand+3)%7];

			neigh5 = NA[(rand+4)%7];

			neigh6 = NA[(rand+5)%7];

			neigh7 = NA[(rand+6)%7];

			

			if( atom.getAtom_no()==1 )

			{	// IF ROOT

				BL = getBondLength(atom.getAtomName(),neigh7.getAtomName());

				neigh7.setPVx( -ax);  neigh7.setPVy(-ay);	neigh7.setPVz(-az);

				neigh7.setCord( x - ax*BL, y - ay*BL, z - az*BL );

				VisitAtom(neigh7);

			}

			

			/* set the Normal */

		        if( az!=0 ){ nx = Math.random(); ny = Math.random(); nz = -(ax*nx+ay*ny)/az; }

			else if( ay!=0 ){ nx = Math.random(); nz = Math.random(); ny = -(ax*nx+az*nz)/ay; }

			else { ny = Math.random(); nz = Math.random(); nx = -(ay*ny+az*nz)/ax; }

			double r = Math.sqrt(nx*nx+ny*ny+nz*nz);

			nx = nx/r;	ny=ny/r;	nz=nz/r;

			double aXnx = ay*nz-ny*az, aXny = az*nx-ax*nz,  aXnz = ax*ny-ay*nx;

			

			if( neigh1.getVisited()==false ){

			BL = getBondLength(atom.getAtomName(),neigh1.getAtomName());

			neigh1.setPVx( ax );

			neigh1.setPVy( ay ) ;

			neigh1.setPVz( az );

			neigh1.setCord( x +BL*neigh1.getPVx() , y + BL*neigh1.getPVy() , z + BL*neigh1.getPVz() );

			VisitAtom(neigh1);

			}

			

			if( neigh2.getVisited()==false ){

			BL = getBondLength(atom.getAtomName(),neigh2.getAtomName());

			neigh2.setPVx( nx );

			neigh2.setPVy( ny );

			neigh2.setPVz( nz );

			neigh2.setCord( x + BL*neigh2.getPVx() ,  y + BL*neigh2.getPVy() , z + BL*neigh2.getPVz() );

			VisitAtom(neigh2);

			}

			

			if( neigh3.getVisited()==false ){

			BL = getBondLength(atom.getAtomName(),neigh3.getAtomName());

			neigh3.setPVx( nx*Cos(72) + aXnx*Sin(72) );

			neigh3.setPVy( ny*Cos(72) + aXny*Sin(72) );

			neigh3.setPVz( nz*Cos(72) + aXnz*Sin(72) );

			neigh3.setCord( x + BL*neigh3.getPVx() ,  y + BL*neigh3.getPVy() , z + BL*neigh3.getPVz() );

			VisitAtom(neigh3);

			}

			

			if( neigh4.getVisited()==false ){

			BL = getBondLength(atom.getAtomName(),neigh4.getAtomName());

			neigh4.setPVx( nx*Cos(144) + aXnx*Sin(144) );

			neigh4.setPVy( ny*Cos(144) + aXny*Sin(144) );

			neigh4.setPVz( nz*Cos(144) + aXnz*Sin(144) );

			neigh4.setCord( x + BL*neigh4.getPVx() ,  y + BL*neigh4.getPVy() , z + BL*neigh4.getPVz() );

			VisitAtom(neigh4);

			}

			

			if( neigh5.getVisited()==false ){

			BL = getBondLength(atom.getAtomName(),neigh5.getAtomName());

			neigh5.setPVx( nx*Cos(216) + aXnx*Sin(216) );

			neigh5.setPVy( ny*Cos(216) + aXny*Sin(216) );

			neigh5.setPVz( nz*Cos(216) + aXnz*Sin(216) );

			neigh5.setCord( x + BL*neigh5.getPVx() ,  y + BL*neigh5.getPVy() , z + BL*neigh5.getPVz() );

			VisitAtom(neigh5);

			}

			

			if( neigh6.getVisited()==false ){

			BL = getBondLength(atom.getAtomName(),neigh5.getAtomName());

			neigh6.setPVx( nx*Cos(288) + aXnx*Sin(288) );

			neigh6.setPVy( ny*Cos(288) + aXny*Sin(288) );

			neigh6.setPVz( nz*Cos(288) + aXnz*Sin(288) );

			neigh6.setCord( x + BL*neigh6.getPVx() ,  y + BL*neigh6.getPVy() , z + BL*neigh6.getPVz() );

			VisitAtom(neigh6);

			}

			

		}	

		

		return;



		

	}



	public double Cos( double arg )

	{

		return Math.cos(Math.PI*arg/180);

	}



	public double Sin( double arg )

	{

		return Math.sin(Math.PI*arg/180);

	}

	

	public void screenFitting()

	{

		Rectangle screenRect = getGraphicsConfiguration().getBounds();

		int yMax = (screenRect.getSize().height)/2-50;

		float zmax,zmin,ymax,ymin,xmax,xmin,r=0;

		float x,y,z,distance;

	

		for(int i=0;i<no_atoms;i++)

		{

			myatom = (NewAtom)atom.elementAt(i);

			x = (float)myatom.getCordX(); y = (float)myatom.getCordY(); z = (float)myatom.getCordZ();

			distance = (float)Math.sqrt(x*x+y*y+z*z);

			if( r < distance ) r = distance;

		}

		if( r<=yMax ) return;

		

		for(int i=0;i<no_atoms;i++)

		{

			myatom = (NewAtom)atom.elementAt(i);

			x = (float)myatom.getCordX(); y = (float)myatom.getCordY(); z = (float)myatom.getCordZ();

			x*=yMax/r;	y*=yMax/r;	z*=yMax/r;

			myatom.setCord(x,y,z);

		}

	}	

	

	public void originSetting()

	{

		float zmean=0,ymean=0,xmean=0,r=0;

		float x,y,z,distance;

	

		for(int i=0;i<no_atoms;i++)

		{

			myatom = (NewAtom)atom.elementAt(i);

			x = (float)myatom.getCordX(); y = (float)myatom.getCordY(); z = (float)myatom.getCordZ();

			xmean += x;	ymean += y;	zmean+=z;		

		}	

		xmean /= no_atoms;	ymean /= no_atoms;	zmean /= no_atoms;

		for(int i=0;i<no_atoms;i++)

		{

			myatom = (NewAtom)atom.elementAt(i);

			x = (float)myatom.getCordX(); y = (float)myatom.getCordY(); z = (float)myatom.getCordZ();

			myatom.setCord(x-xmean,y-ymean,z-zmean);	

		}	

	}	

	

	public void MoleculeError()

	{

		JDialog ME = new JDialog(this," Error in the Molecule",true) ;

		ME.setSize(new Dimension(200,70));

		ME.getContentPane().add(new JLabel("      Error in the Molecule"));

		ME.setVisible(true);

		atom = new Vector(15,1);

		Bonds = new Vector(20,1);

		g.setColor(Color.black);

		g.fillRect(0,0,490,330);

		dragAtom = 0;

		no_atoms = 0;

		no_bonds = 0;

		bondatomno=0;

		canDrawBond = false;

		newMoleculeName = "";	

	}	

	

	public float getBondLength(String A1,String A2) 

	{

		if( A1.equals("H") || A2.equals("H") )

			return 80;

		return 150;

	}	

	

	public String getNewMoleculeName()

	{

		return newMoleculeName;

	}		

}

	



class MoleculeInput extends Dialog implements ActionListener

{

	TextField name;

	JFrame myFrame;

	

	MoleculeInput(JFrame myFrame, boolean mode)

	{

		super(myFrame," Enter the Molecule Name ", true);

		this.myFrame = myFrame;

		setSize(320,110);

		JButton OK;

		Label label;

		Box box = Box.createVerticalBox();

		label = new Label("      Enter the Molecule Name ");

		box.add(label);

		name = new TextField(30);

		box.add(name);

		JButton OK1 = new JButton("OK");

		OK1.addActionListener(this);

		box.add(OK1);

		add(box);

	}

	

	public void actionPerformed(ActionEvent ae)

	{

		String ss,s = name.getText();

		if( s=="\n" || s=="" || s==null || s.trim()=="" )

		{

			JDialog jd = new JDialog(this,"  Incorrect Name.. ",true);

			jd.getContentPane().add( new JLabel("  Enter the Name Correctly " ));

			jd.setSize(new Dimension(350,60)); 

			jd.setVisible(true);

			name.setText("");

			return;

		}	

		try{	

			FileReader fr = new FileReader("MV\\MoleculeList.txt");

			BufferedReader br = new BufferedReader(fr);

			while( (ss=br.readLine())!="\n" && ss!=null )

			{

				if( ss.equalsIgnoreCase(s) )

				{

					MyNewDialog jd = new MyNewDialog(myFrame,"This Molecule already EXISTS. Replace it ?",true);

					if( (jd.getAction()).equals("No"))

						name.setText("");

					else name.setText(s.trim());	

					break;

				}	

			}	

		}catch( Exception e){ System.out.println("Cant force duplicacy check"); }

		dispose();

	}

	

	public String getName()

	{

		return name.getText();

	}	

	

}		

			

class MyNewDialog extends JDialog implements ActionListener

{

	String action;

	

	public MyNewDialog( JFrame jf, String data, boolean state)

	{

		super(jf,data,state);

		setSize(new Dimension(360,90) );

		action = "";

		JButton Yes = new JButton("Yes");

  		JButton No  = new JButton("No");

  		Yes.addActionListener(this);

  		No.addActionListener(this);

  		Box b = Box.createVerticalBox();

  		b.add(new JLabel(data));

  		Box subbox = Box.createHorizontalBox();

  		subbox.add(Box.createHorizontalGlue());

  		subbox.add(No); subbox.add(Box.createHorizontalGlue());	subbox.add(Yes);

  		subbox.add(Box.createHorizontalGlue());

  		b.add(Box.createVerticalGlue());

  		b.add(subbox);

  		getContentPane().add(b);

  		setVisible(true);

	}

	

	public void actionPerformed(ActionEvent ae)

	{

		String com = ae.getActionCommand();

		if( com.equals("Yes") )

			action = "Yes";

		else action = "No";	

		dispose();	

	}

	

	public String getAction(){	return action;	}

}	